MantisBT

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0002459VCMIOtherpublic2016-08-19 20:272016-09-16 03:20
ReporterSXX 
Assigned ToSXX 
PrioritynormalSeveritymajorReproducibilityalways
StatusresolvedResolutionfixed 
PlatformOSOS Version
Product Version0.98g 
Target VersionFixed in Version0.99 
Summary0002459: Desync found! - Work toward full sync of save games
DescriptionAt moment after week with memcheck we fixed all uninitialized value reports that related to serializer as well as some leaks. End goal is to make sure save games are in sync between client and server.

Currently we found few important desync points:

CGHeroInstance::SecondarySkillsInfo::rand. First one occur probably since there might be some not initialized heroes on map and so we just set same initial seed for SecondarySkillsInfo rand.

Another one is CGameState::rand. First issue here is at least:
CGameHandler::init. There is code of Beegee that randomize server-side gamestate. Though even with that commented server heavily use rand from GS and client doesn't so it's not easy to fix.

Last one is static "CGObelisk::visited;" in CMap serialize even on maps that don't have obelisks. Though I didn't have chance to investigate this one since.
TagsNo tags attached.
Attached Files

- Relationships
parent of 0002383resolvedSXX AI infinitely loops with this save - secSkill desync 
parent of 0002460resolvedSXX CGameHandler::setFormation need proper netpack with applyGs 
parent of 0002462resolvedSXX PlayerState::daysWithoutCastle desync due to CGameHandler code 
parent of 0002463resolvedSXX CGameHandler::levelUpHero desync SecondarySkillsInfo RNG 
parent of 0002464resolvedSXX NewStructures::applyCl desync after town appearance changed 
related to 0002168closedSXX Terra incognito 

-  Notes
(0006574)
SXX (administrator)
2016-08-19 20:59

So this one affect at least:

* Heroes skills as posted above.
* Any object created by NewObject::applyGs
(0006630)
SXX (administrator)
2016-09-07 22:22

PR for most of issues:

https://github.com/vcmi/vcmi/pull/209 [^]
(0006648)
SXX (administrator)
2016-09-12 00:42

All I find should be fixed with PR209 merge:
https://github.com/vcmi/vcmi/commit/2543e068acd7e91ad4234ddfd7622c5e4fac664f [^]

Will add related entries to this one in case I find out something else.

- Issue History
Date Modified Username Field Change
2016-08-19 20:27 SXX New Issue
2016-08-19 20:27 SXX Status new => assigned
2016-08-19 20:27 SXX Assigned To => SXX
2016-08-19 20:27 SXX Relationship added related to 0002383
2016-08-19 20:44 SXX Relationship deleted related to 0002383
2016-08-19 20:44 SXX Relationship added parent of 0002383
2016-08-19 20:59 SXX Note Added: 0006574
2016-08-23 03:39 SXX Relationship added parent of 0002460
2016-08-23 04:19 SXX Relationship added parent of 0002462
2016-08-23 05:00 SXX Relationship added related to 0002072
2016-08-23 05:00 SXX Relationship deleted related to 0002072
2016-08-23 05:10 SXX Relationship added parent of 0002089
2016-08-23 22:01 SXX Relationship added parent of 0002463
2016-08-24 00:18 SXX Summary Desync found! - Works towards full sync of save games => Desync found! - Work toward full sync of save games
2016-08-24 00:48 SXX Relationship added parent of 0002464
2016-09-07 22:22 SXX Note Added: 0006630
2016-09-11 10:11 SXX Relationship deleted parent of 0002089
2016-09-12 00:42 SXX Note Added: 0006648
2016-09-12 00:42 SXX Status assigned => resolved
2016-09-12 00:42 SXX Fixed in Version => 0.99
2016-09-12 00:42 SXX Resolution open => fixed
2016-09-16 03:20 SXX Relationship added related to 0002168

Site | Forums | Wiki | Slack | GitHub


Copyright © 2000 - 2018 MantisBT Team
Hosting provided by DigitalOcean